#ifdef _WIN32
	#pragma warning(disable:4996)
	#include <conio.h>
	#include <direct.h>
#elif (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	#include <stdlib.h>
	#include <sys/types.h>
	#include <sys/stat.h>
	#include <unistd.h>
	typedef char _TCHAR;
	#define _tmain main
#endif

#include <stdio.h>
#include <iostream>
#include <iomanip>
using namespace std;

#include "CisloKomplexne.h"
//---------------------------------------------------------------------------
TCisloKomplexne::TCisloKomplexne()
{
	Re = 0;
	Im = 0;
}
//---------------------------------------------------------------------------
TCisloKomplexne::TCisloKomplexne(const float re,const float im)
{
	Re = re;
	Im = im;
}
//---------------------------------------------------------------------------
TCisloKomplexne::~TCisloKomplexne()
{
}
//---------------------------------------------------------------------------
TCisloKomplexne& TCisloKomplexne::operator=(const TCisloKomplexne& X)
{
	if (this == &X) return *this;
	Re = X.Re;
	Im = X.Im;

	return *this;
}
//---------------------------------------------------------------------------
const TCisloKomplexne operator+(const TCisloKomplexne& X,const TCisloKomplexne& Y)
{
	TCisloKomplexne Z;

	Z.Re = X.Re + Y.Re;
	Z.Im = X.Im + Y.Im;

	return Z;
}
//---------------------------------------------------------------------------
const TCisloKomplexne operator*(const TCisloKomplexne& X,const TCisloKomplexne& Y)
{
	TCisloKomplexne Z;

	Z.Re = X.Re*Y.Re - X.Im*Y.Im;
	Z.Im = X.Re*Y.Im + X.Im*Y.Re;

	return Z;
}
//---------------------------------------------------------------------------
TCisloKomplexne TCisloKomplexne::HermitovskyZdruzene()
{
	TCisloKomplexne Y;

	Y = *this;
	Y.Im = -Im;

	return Y;
}
//---------------------------------------------------------------------------
istream& operator>>(istream& is, TCisloKomplexne& com)
{
	float x;
	char c1,c2;

	do {
		is.get(c1);
	} while (isspace(c1));

	if (c1=='i') {
		com.Re=0;
		com.Im=1;
		return is;
	} else
		is.putback(c1);

	c1 = ' ';
	is >> x;
	is.get(c1);
	if (c1!='i'){
		com.Re=x;
		if ((c1!='+')&&(c1!='-'))
			com.Im=0;
		else{
			is >> com.Im >> c2;
			if (c1=='-')
			com.Im=(-1)*com.Im;
		}
	}else{
		com.Re=0;
		com.Im=x;
	}

	return is;
}
//---------------------------------------------------------------------------
ostream& operator<<(ostream& os, const TCisloKomplexne& com)
{
	os.setf(ios::fixed,ios::floatfield);
	os.precision(2);
	if ((com.Re!=0)||(com.Im==0))
		os << setw(6) << com.Re;
	else
		os << "     ";

	if (com.Im!=0){
		if (com.Re!=0)
			os.setf(ios::showpos);
		else if (com.Im>0)
			os << " ";
		os << setw(8) << com.Im << 'i';
		os.unsetf(ios::showpos);
	}else{
		os << "         ";
	}

	return os;
}
//---------------------------------------------------------------------------

